;Same as tutorial 04, but using the PureZIP_W library to compress the pdf file

#PurePDF_Include=1
XIncludeFile "PurePDF.pb"

Global title.s
Global col.f
Global y0.f
title="20000 Leagues Under the Seas"

CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Linux
    #ZLIB_IMPORT_PATH = #PB_Compiler_Home + "purelibraries/linux/libraries/zlib.a"
  CompilerCase #PB_OS_Windows
    #ZLIB_IMPORT_PATH = "zlib.lib"
  CompilerCase #PB_OS_MacOS
    #ZLIB_IMPORT_PATH = "/usr/lib/libz.dylib"
CompilerEndSelect

ImportC #ZLIB_IMPORT_PATH
  _compress.l(*dest, *destlen, *source, sourcelen) As "_compress"
EndImport

Procedure.l PDFCompress(*aData.MEM_DataStructure)
  Protected zerr,CompMem,SourceLen,SourceMem,CompLen,lbError
  
  lbError = #False
  SourceLen = *aData\lCurSize
  SourceMem = *aData\pData 
  CompLen   = Round(1.001 * SourceLen,#PB_Round_Up) + 12
  CompMem   = AllocateMemory(CompLen)
  If CompMem
    zerr=_compress(CompMem,@CompLen,SourceMem,SourceLen)
    If zerr = 0
      *aData\pData = CompMem
      *aData\lMaxSize = CompLen
      *aData\lCurSize = CompLen
      FreeMemory(Sourcemem)
      lbError = #True 
    EndIf
  EndIf
  ProcedureReturn lbError  
EndProcedure

pdf_Create()
pdf_SetProcCompression(@PDFCompress())

pdf_AddPage()

pdf_SetFont("Tahoma","",12)
pdf_Text(10,10,"This is an embedded font (Tahoma Size 12)")

pdf_SetFont("Tahoma","B",12)
pdf_Text(10,20,"This is an embedded font (Tahoma Size 12 Bold)")

pdf_SetFont("Tahoma","U",12)
pdf_Text(10,30,"This is an embedded font (Tahoma Size 12 Underlined)")

pdf_SetFont("Tahoma","BU",12)
pdf_Text(10,40,"This is an embedded font (Tahoma Size 12) Bold+Underlined")

Define file$="Tutorial22 Font.pdf"

pdf_Save(file$)
RunProgram(file$)
; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 2
; Folding = -
; DisablePurifier = 1,1,1,1